package betterwithmods.common.blocks.mechanical;

import betterwithmods.common.BWMItems;
import betterwithmods.common.blocks.tile.gen.IColor;
import betterwithmods.common.blocks.tile.gen.TileEntityMillGenerator;
import betterwithmods.common.blocks.tile.gen.TileEntityWindmillHorizontal;
import betterwithmods.common.blocks.tile.gen.TileEntityWindmillVertical;
import betterwithmods.util.ColorUtils;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import java.util.Random;

public class BlockWindmill extends BlockMillGenerator {
    public BlockWindmill() {
        super(Material.field_151575_d);
    }

    @Override
    public ItemStack func_185473_a(World world, BlockPos pos, IBlockState state) {
        return new ItemStack(BWMItems.WINDMILL, 1, state.func_177229_b(AXIS) == EnumFacing.Axis.Y ? 2 : 0);
    }

    @Override
    public void func_176213_c(World world, BlockPos pos, IBlockState state) {
        super.func_176213_c(world, pos, state);
        if (world.func_175625_s(pos) != null && world.func_175625_s(pos) instanceof TileEntityMillGenerator) {
            boolean active;
            if (state.func_177229_b(AXIS) == EnumFacing.Axis.Y)
                active = ((TileEntityWindmillVertical) world.func_175625_s(pos)).isValid();
            else
                active = ((TileEntityWindmillHorizontal) world.func_175625_s(pos)).isValid();
            world.func_175656_a(pos, state.func_177226_a(ISACTIVE, active));
        }
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        ItemStack stack = player.func_184586_b(hand);
        TileEntity tile = world.func_175625_s(pos);

        if (world.field_72995_K && !stack.func_190926_b() && ColorUtils.contains(stack.func_77973_b(), stack.func_77952_i()))
            return true;

        if (!world.field_72995_K && tile != null && tile instanceof IColor && !stack.func_190926_b() && ColorUtils.contains(stack.func_77973_b(), stack.func_77952_i())) {
            IColor color = (IColor) tile;
            int meta = ColorUtils.get(stack.func_77973_b(), stack.func_77952_i()); //reverseMeta[stack.getItemDamage()];
            if (color.dyeBlade(meta)) {
                if (!player.field_71075_bZ.field_75098_d)
                    stack.func_190918_g(1);
                return true;
            }
        }
        return false;
    }

    @Override
    public Item func_180660_a(IBlockState state, Random rand, int fortune) {
        return BWMItems.WINDMILL;
    }

    @Override
    public int func_180651_a(IBlockState state) {
        return state.func_177229_b(AXIS) == EnumFacing.Axis.Y ? 2 : 0;
    }

    @Override
    public boolean hasTileEntity(IBlockState state) {
        return true;
    }

    @Override
    public TileEntity createTileEntity(World world, IBlockState state) {
        if (state.func_177229_b(AXIS) == EnumFacing.Axis.Y)
            return new TileEntityWindmillVertical();
        else
            return new TileEntityWindmillHorizontal();
    }

    @Override
    public ItemStack getGenStack(IBlockState state) {
        return state.func_177229_b(AXIS) == EnumFacing.Axis.Y ? new ItemStack(BWMItems.WINDMILL, 1, 2) : new ItemStack(BWMItems.WINDMILL, 1, 0);
    }
}
