package betterwithmods.common.registry;

import betterwithmods.BWMod;
import betterwithmods.common.BWOreDictionary;
import net.minecraft.init.Items;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.Ingredient;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent;

/**
 * Created by blueyu2 on 12/12/16.
 */
public class ChoppingRecipe extends ToolDamageRecipe {
    private BWOreDictionary.Wood wood;

    public ChoppingRecipe(BWOreDictionary.Wood wood) {
        super(new ResourceLocation(BWMod.MODID, "chopping"), wood.getPlank(2), Ingredient.func_193369_a(wood.getLog(1)), ChoppingRecipe::isAxe);
        this.wood = wood;
        MinecraftForge.EVENT_BUS.register(this);
    }

    @Override
    public ItemStack getExampleStack() {
        return new ItemStack(Items.field_151036_c);
    }

    private static boolean isAxe(ItemStack stack) {
        if (stack != null) {
            if (stack.func_77973_b().getToolClasses(stack).contains("axe")) {
                if (stack.func_77973_b().getRegistryName().func_110624_b().equals("tconstruct")) {
                    if (stack.func_77952_i() >= stack.func_77958_k())
                        return false;
                }
                return true;
            }
        }
        return false;
    }

    @SubscribeEvent
    public void dropExtra(PlayerEvent.ItemCraftedEvent event) {
        if (event.player == null)
            return;
        if (isMatch(event.craftMatrix, event.player.field_70170_p)) {
            if (!event.player.func_130014_f_().field_72995_K) {
                event.player.func_70099_a(wood.getSawdust(1), 0);
                event.player.func_70099_a(wood.getBark(1), 0);
            } else {
                event.player.func_184185_a(SoundEvents.field_187927_ha, 0.25F, 2.5F);
            }
        }
    }
}

